package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TarifaGrupoContratoDAO;
import com.rjconsultores.ventaboletos.entidad.TarifaGrupoContrato;
import com.rjconsultores.ventaboletos.vo.configuracioneccomerciales.TarifaGrupoContratoVO;

@SuppressWarnings("unchecked")
@Repository("tarifaGrupoContratoDAO")
public class TarifaGrupoContratoHibernateDAO extends GenericHibernateDAO<TarifaGrupoContrato, Integer> implements TarifaGrupoContratoDAO {

    @Autowired
    public TarifaGrupoContratoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

	@Override
    public List<TarifaGrupoContrato> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

	@Override
	public boolean gravarTarifasGrupoContrato(List<TarifaGrupoContrato> tarifas) {

		for (TarifaGrupoContrato tarifa : tarifas) {
			if(tarifa.getTarifaGrupoContratoId() == null) {
				suscribir(tarifa);
			}else {
				actualizacion(tarifa);
			}
		}

		return true;
	}

	@Override
	public TarifaGrupoContrato obterTarifaPeloVo(TarifaGrupoContratoVO tarifa) {
		if( tarifa.getTarifaGrupoContratoId() != null ) {
			return obtenerID(tarifa.getTarifaGrupoContratoId());
		}
		return null;
	}
}
